<?php

namespace Garradin;

use Garradin\Plugin\Materiels\Entry;
use Garradin\Plugin\Materiels\Equipment;
use Garradin\Utils;

require_once __DIR__ . '/../_inc.php';

$entry = new Entry;

$csrf_key = 'add_entry';

if (f('save') && $form->check($csrf_key) && !$form->hasErrors())
{
  $entry = new Entry;
  $entry_date_format = date_create_from_format(
    "d/m/Y", f('entry_date'))->format("Y-m-d");
  $entry->add([
    'kind' => f('kind'),
    'equipment_number' => (int) f('equipment_number'),
    'equipment_id' => f('equipment_id'),
    'entry_date' => $entry_date_format,
    'additional_comment' => f('additional_comment'),
  ]);
  Utils::redirect(PLUGIN_URL . 'entrees/index.php');
}

$eqmt = new Equipment;
$eqmts_by_cat = $eqmt->listAllByCategory();

$kinds = $entry->listKinds();
$selected_kind = $kinds[0];

$date = new \DateTime;
$date->setTimestamp(time());
$default_date = $date;

$default_number = "1";
$default_comment = "";

$cancel_link = PLUGIN_URL . 'entrees/index.php';
$legend_part = "répertorié";
$tpl_materiel_name = "repertorie";


$tpl->assign(compact(
  'kinds', 'eqmts_by_cat', 'selected_kind', 'default_date',
  'default_number', 'default_comment', 'cancel_link',
  'legend_part', 'tpl_materiel_name', 'csrf_key'
));

$tpl->display(PLUGIN_ROOT . '/templates/entrees/ajouter_entree.tpl');
